package desktophe;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.swt.graphics.Device;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.program.Program;

/**
 * gqɊ֘AtĂACRC[WǗNX
 * 
 * @author kohno
 */
public class ImageManager {
	private static ImageManager imageManager_ = null;
	Map imageMap_;

	/**
	 * RXgN^
	 */
	private ImageManager() {
		imageMap_ = new HashMap();
	}

	/**
	 * ImageManager̃CX^XԂ\bh
	 * 
	 * @return ImageManager̃CX^X
	 */
	public static ImageManager getInstance() {
		if (imageManager_ == null) {
			imageManager_ = new ImageManager();
		}
		
		return imageManager_;
	}
	
	/**
	 * w肳ꂽgqɊ֘AtĂACRC[WԂ\bh
	 * 
	 * @param device C[W쐬foCX
	 * @param ext gq
	 * @return w肳ꂽgqɊ֘AtĂACRC[W
	 */
	public Image getImage(Device device, String ext) {
		Object o = imageMap_.get(ext);
		
		if (o != null)  return (Image)o;
			
		Image img = null;
			
		Program p = Program.findProgram(ext);
		if (p != null) {
			ImageData imagedata = p.getImageData ();
			if (imagedata != null) {
				img = new Image(device, imagedata);
				imageMap_.put(ext, img);
			}
		}
		
		return img;
	}

	/**
	 * ێĂf[^郁\bh
	 */
	public void dispose() {
		Collection col = imageMap_.values();
		Iterator iterator = col.iterator();
		
		while (iterator.hasNext()) {
			Object o = iterator.next();
			
			assert (o instanceof Image);
			
			Image img = (Image)o;
			img.dispose();
		}
	}
}
