package desktophe.model;

import java.util.Properties;

import desktophe.Messages;

/**
 * ㋉ҌCfbNXݒ̓eێ邽߂̃NX
 * 
 * @author kohno
 */
public class AdvancedIndexSettingModel {

	/** CfbNXR}h */
	private String indexCommand_;
	
	/** MSItBXt@CCfbNXR}h */
	private String indexOfficeFileCommand_;
	
	/** purgeR}h */
	private String purgeCommand_;
	
	/** L[[hoR}h */
	private String extractKeywordsCommand_;
	
	/** f[^x[XœKR}h */
	private String optimizeCommand_;
	
	
	/**
	 * RXgN^
	 */
	public AdvancedIndexSettingModel() {
		indexCommand_ = Messages.getString("AdvancedIndexSettingModel.IndexCommand"); //$NON-NLS-1$
		indexOfficeFileCommand_ = 
			Messages.getString("AdvancedIndexSettingModel.IndexOfficeFileCommand"); //$NON-NLS-1$
		purgeCommand_ = Messages.getString("AdvancedIndexSettingModel.PurgeCommand"); //$NON-NLS-1$
		extractKeywordsCommand_ = Messages.getString("AdvancedIndexSettingModel.ExtractKeywordsCommand"); //$NON-NLS-1$
		optimizeCommand_ = Messages.getString("AdvancedIndexSettingModel.OptimizeCommand"); //$NON-NLS-1$
	}

	/**
	 * @return indexCommand_ ߂܂B
	 */
	public String getIndexCommand() {
		return indexCommand_;
	}

	/**
	 * @param indexCommand_ ݒ肷 indexCommand_B
	 */
	public void setIndexCommand(String indexCommand) {
		this.indexCommand_ = indexCommand;
	}

	/**
	 * @return indexOfficeFileCommand_ ߂܂B
	 */
	public String getIndexOfficeFileCommand() {
		return indexOfficeFileCommand_;
	}

	/**
	 * @param indexOfficeFileCommand_ ݒ肷 indexOfficeFileCommand_B
	 */
	public void setIndexOfficeFileCommand(String indexOfficeFileCommand) {
		this.indexOfficeFileCommand_ = indexOfficeFileCommand;
	}

	/**
	 * @return purgeCommand_ ߂܂B
	 */
	public String getPurgeCommand() {
		return purgeCommand_;
	}

	/**
	 * @param purgeCommand_ ݒ肷 purgeCommand_B
	 */
	public void setPurgeCommand(String purgeCommand) {
		this.purgeCommand_ = purgeCommand;
	}

	/**
	 * @return extractKeywordsCommand_ ߂܂B
	 */
	public String getExtractKeywordsCommand() {
		return extractKeywordsCommand_;
	}

	/**
	 * @param extractKeywordsCommand_ ݒ肷 extractKeywordsCommand_B
	 */
	public void setExtractKeywordsCommand(String extractKeywordsCommand) {
		this.extractKeywordsCommand_ = extractKeywordsCommand;
	}

	/**
	 * @return optimizeCommand_ ߂܂B
	 */
	public String getOptimizeCommand() {
		return optimizeCommand_;
	}

	/**
	 * @param optimizeCommand_ ݒ肷 optimizeCommand_B
	 */
	public void setOptimizeCommand(String optimizeCommand) {
		this.optimizeCommand_ = optimizeCommand;
	}

	/**
	 * nꂽProperties ̃CX^XAݒlǂݏo\bh
	 * 
	 * @param prop ݒlǂݏoProperties
	 */
	public void load(Properties prop) {
		{
			String str = prop.getProperty("AdvancedIndexSettingModel_indexCommand");
			if (str != null)  indexCommand_ = str;
		}
		
		{
			String str = prop.getProperty("AdvancedIndexSettingModel_indexOfficeFileCommand");
			if (str != null)  indexOfficeFileCommand_ = str;
		}

		{
			String str = prop.getProperty("AdvancedIndexSettingModel_purgeCommand");
			if (str != null)  purgeCommand_ = str;
		}

		{
			String str = prop.getProperty("AdvancedIndexSettingModel_extractKeywordsCommand");
			if (str != null)  extractKeywordsCommand_ = str;
		}

		{
			String str = prop.getProperty("AdvancedIndexSettingModel_optimizeCommand");
			if (str != null)  optimizeCommand_ = str;
		}
	}

	/**
	 * nꂽProperties ɐݒlL^郁\bh
	 * 
	 * @param prop ݒlL^Properties
	 */
	public void save(Properties prop) {
		prop.setProperty("AdvancedIndexSettingModel_indexCommand", 				indexCommand_);
		prop.setProperty("AdvancedIndexSettingModel_indexOfficeFileCommand", 	indexOfficeFileCommand_);
		prop.setProperty("AdvancedIndexSettingModel_purgeCommand", 				purgeCommand_);
		prop.setProperty("AdvancedIndexSettingModel_extractKeywordsCommand", 	extractKeywordsCommand_);
		prop.setProperty("AdvancedIndexSettingModel_optimizeCommand", 			optimizeCommand_);
	}
}
