#include "stdafx.h"


/** DesktopHEN̂ɕKvJRẼo[W */
static const float NEEDED_JRE_VERSION = 1.4;

/** JRẼCXg[ɎgpURL */
static const TCHAR* JRE_URL = "http://freemind.s57.xrea.com/desktophe/java.html";

/**
 * WXgJRẼfBNgǂݏo֐
 */
std::string GetJRENDirectory()
{
	HKEY hkey;
	LONG retCode;
	
	retCode = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\JavaSoft\\Java Runtime Environment", 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_READ, NULL, &hkey, NULL);
		
	if (retCode != ERROR_SUCCESS) {
		int ret = MessageBox(NULL, 
			"WXgL[擾G[\r\n"
			"HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Runtime Environment\r\n\r\n"
		    "JRE(J2SE Runtime Environment)CXg[ĂȂ\܂B\r\n"
			"JRECXg[܂H", 
		    "error", MB_YESNO | MB_ICONERROR);
			
		if (ret == IDYES) {
			ShellExecute(NULL, "open", JRE_URL, NULL, NULL, SW_SHOW);		
		}
		
		return "";
	}
	
	BYTE data[1024] = {0};
	DWORD size = 1024;
	retCode = RegQueryValueEx(hkey, "CurrentVersion", NULL, NULL, data, &size);
	
	if (retCode != ERROR_SUCCESS) {
	    RegCloseKey(hkey);
	
		int ret = MessageBox(NULL, 
			"WXgL[擾G[\r\n"
			"HKEY_LOCAL_MACHINE\\SOFTWARE\\JavaSoft\\Java Runtime Environment\\CurrentVersion\r\n\r\n"
		    "JRE(J2SE Runtime Environment)CXg[ĂȂ\܂B\r\n"
			"JRECXg[܂H", 
		    "error", MB_YESNO | MB_ICONERROR);
			
		if (ret == IDYES) {
			ShellExecute(NULL, "open", JRE_URL, NULL, NULL, SW_SHOW);		
		}
		
		return "";
	}
	
	float version = atof(data);
	
	if (version < NEEDED_JRE_VERSION) {
	    RegCloseKey(hkey);
		
		TCHAR buf[1024];
		wsprintf(buf, 
			"CXg[ĂJRẼo[WADesktopHEŕKvȂ̂Â̂łB\r\n"
			"JRE 1.4ȍ~CXg[ĂB\r\n\r\n"
		    "CXg[Ăo[W: %s\r\n\r\n"
			"JRECXg[܂H",
		    data);
		int ret = MessageBox(NULL, buf, "error", MB_YESNO | MB_ICONERROR);

		if (ret == IDYES) {
			ShellExecute(NULL, "open", JRE_URL, NULL, NULL, SW_SHOW);		
		}

		return "";
	}

    // TuL[񋓂
	TCHAR bufKeyName[256];
	DWORD nameLen;
	FILETIME time;
	LONG ret;
	float versionNum = 0.0f;
	std::string versionStr = "";
	
	for (int index=0; ; index++) {
		nameLen = 256;
    	ret = RegEnumKeyEx(hkey, index, bufKeyName, &nameLen, NULL, NULL, NULL, &time); 	
		
		if (ret == ERROR_NO_MORE_ITEMS)  break;
		
		if (atof(bufKeyName) > versionNum) {
		    versionNum = atof(bufKeyName);	
			versionStr = bufKeyName;
		}
	}
	
    RegCloseKey(hkey);

	if (versionStr.length() == 0) {
	    MessageBox(NULL, "TuL[̗񋓂Ɏs܂B\r\nJRECXg[ĂȂ\܂B", 
		    "error", MB_OK | MB_ICONERROR);
		return "";	
	}
	
    std::string regKey = "SOFTWARE\\JavaSoft\\Java Runtime Environment\\";
	regKey += versionStr;

	retCode = RegCreateKeyEx(HKEY_LOCAL_MACHINE, regKey.c_str(), 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_READ, NULL, &hkey, NULL);
		
	if (retCode != ERROR_SUCCESS) {
		TCHAR buff[1024];
		wsprintf(buff, "WXgL[擾G[\r\n%s\r\n\r\nJRECXg[ĂȂ\܂B",
		    regKey.c_str());
		MessageBox(NULL, buff, "error", MB_OK | MB_ICONERROR);
		return "";
	}
	
	size = 1024;
	RegQueryValueEx(hkey, "JavaHome", NULL, NULL, data, &size);
    RegCloseKey(hkey);
	
	return (char*)data;
}



int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	std::string jreDirectory = GetJRENDirectory();
	
	if (jreDirectory.length() == 0)  return 1;
	
	std::string exepath(__argv[0]);    // vOtH_
	exepath = exepath.substr(0, exepath.find_last_of("\\"));
	
	SetCurrentDirectory(exepath.c_str());
	
	std::string classpath;
	classpath = ".;estraier.jar;swt.jar;desktophelib.jar;hidemarumailPlugin.jar";

	std::string command;
	
	command = "\"";
	command += jreDirectory;
	command += "\\bin\\javaw\" -ea -Xms8m -Xmx256m -classpath ";
	command += classpath;
	command += " ";
	command += "-Dclasspath=";
	command += classpath;
	command += " ";
	command += "desktophe.Main";
	
	STARTUPINFO startupinfo;
	PROCESS_INFORMATION proc_info;
	TCHAR command_t[2048];
	lstrcpy(command_t, command.c_str());

	ZeroMemory(&startupinfo, sizeof(startupinfo));
	startupinfo.cb = sizeof(startupinfo);
	startupinfo.dwFlags = STARTF_USESHOWWINDOW;
	startupinfo.wShowWindow = SW_SHOW;

	BOOL ret;
	ret = CreateProcess(NULL, command_t, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, 
		&startupinfo, &proc_info);
}
