package hidemarumail;

import java.io.File;
import java.io.IOException;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;

import estraier.Document;

public class HidemaruMailPlugin {

	/**
	 * nꂽStringBufferɁACfbNXR}hރ\bh
	 * 
	 * @param buffer
	 */
	public void appendIndexCommand(StringBuffer buffer) {
		buffer.append("%JAVA_EXE% ");
		buffer.append("-ea -cp %CLASS_PATH% hidemarumail.Main ");
		buffer.append("%INDEX_DIRECTORY% ");
		buffer.append("%PROFILE_DIRECTORY%" );
		buffer.append("\n");

		buffer.append("Gۃ[̃f[^CfbNXĂ܂...\n");
	}

	/**
	 * 
	 */
	public void appendPurgeCommand(String indexPath, StringBuffer buffer) {
		buffer.append("%JAVA_EXE% -ea -cp .;bin;lib\\estraier.jar;Y:\\MyProjects\\Java\\DesktopHE\\WORK\\branches\\PlugIn\\DesktopHeHidemaruMailPlugin\\bin hidemarumail.remover.Main "); 
		buffer.append( indexPath );
		buffer.append("\n");
		buffer.append("Gۃ[̃f[^폜Ă܂......\n");
	}

	/**
	 * CfbNXf[^폜邩ǂq˂郁bZ[WԂ\bh
	 * 
	 * @return
	 */
	public String getDeleteConfirmMessage() {
		return "Gۃ[̃f[^CfbNXȂ悤ݒ肵܂B\nCfbNXGۃ[̃f[^폜܂H";
	}

	/**
	 * t@Cc[ŉENbNꂽƂAƎ̃|bvAbvj[\
	 * 
	 * @param shell
	 * @param x j[\ʒuXW
	 * @param y j[\ʒuYW
	 * @param document IꂽhLg
	 */
	public static void showPopupMenu(Shell shell, int x, int y, 
			final String uri, final String realPath) {
		Menu menu = new Menu(shell, SWT.POP_UP);
		
		{
			MenuItem menuItem = new MenuItem (menu, SWT.PUSH);
			menuItem.setText ("Gۃ[ł̃[I");
			menuItem.addSelectionListener(new SelectionListener() {
				public void widgetDefaultSelected(SelectionEvent arg0) {
				}

				public void widgetSelected(SelectionEvent arg0) {
					String filepath = realPath;
					
					if (filepath.indexOf(' ') >= 0) {
						filepath = "\"" + filepath + "\"";
					}
					
					String offset = uri.substring( uri.lastIndexOf(':') + 1 );
					String exePath = Util.getHidemaruMailProgramPath() + File.separator + "TuruKame.exe";
					
					try {
						Runtime.getRuntime().exec(exePath + " /vf " + filepath + " " + offset);
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			});
		}
		
		menu.setLocation (x, y);
		menu.setVisible (true);
	}

	/**
	 * w肳ꂽhLguJv
	 * 
	 * @param document
	 */
	public static void openDocument(Document document) {
		String filepath = document.attr("_lreal");
		
		if (filepath.indexOf(' ') >= 0) {
			filepath = "\"" + filepath + "\"";
		}
		
		String uri = document.attr("@uri");
		String offset = uri.substring( uri.lastIndexOf(':') + 1 );
		
		String exePath = Util.getHidemaruMailProgramPath() + File.separator + "TuruKame.exe";
		
		try {
			Runtime.getRuntime().exec(exePath + " /vf " + filepath + " " + offset);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
