#include "hidemarumail_Util.h"
#include <windows.h>

JNIEXPORT jstring JNICALL Java_hidemarumail_Util_getHidemaruMailDataFolder(JNIEnv* env, jclass obj)
{
	HKEY hkey;
	LONG retCode;
	
	retCode = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Hidemaruo\\TuruKame\\Config", 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_EXECUTE, NULL, &hkey, NULL);
		
	if (retCode != ERROR_SUCCESS) {
		MessageBox(NULL, "WXgL[擾G[\r\nHKEY_CURRENT_USER\\Software\\Hidemaruo\\TuruKame\\Config", 
			"error", MB_OK);

		jstring result = env->NewStringUTF("");
		return result;
	}
	
	BYTE data[2048] = {0};
	
	ZeroMemory(data, 2048);
	
	DWORD size = 1024;
	RegQueryValueEx(hkey, "HomeDir", NULL, NULL, data, &size);
	RegCloseKey(hkey);
	
	data[size] = 0;
	data[size + 1] = 0;
	
	jstring result = env->NewStringUTF(data);
	return result;
}

JNIEXPORT jstring JNICALL Java_hidemarumail_Util_getHidemaruMailProgramPath(JNIEnv* env, jclass obj)
{
	HKEY hkey;
	LONG retCode;
	
	retCode = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Hidemaruo\\TuruKame\\Config", 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_EXECUTE, NULL, &hkey, NULL);
		
	if (retCode != ERROR_SUCCESS) {
		MessageBox(NULL, "WXgL[擾G[\r\nHKEY_CURRENT_USER\\Software\\Hidemaruo\\TuruKame\\Config", 
			"error", MB_OK);

		jstring result = env->NewStringUTF("");
		return result;
	}
	
	BYTE data[2048] = {0};
	
	ZeroMemory(data, 2048);
	
	DWORD size = 1024;
	RegQueryValueEx(hkey, "TuruKameDir", NULL, NULL, data, &size);
	RegCloseKey(hkey);
	
	data[size] = 0;
	data[size + 1] = 0;
	
	jstring result = env->NewStringUTF(data);
	return result;
}

