/**
 * 
 */
package desktophe;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.eclipse.swt.widgets.Display;

import desktophe.dialog.ProgressDialog;

/**
 * OvZX̏o͂󂯎Xbh
 * 
 * @author kohno
 */
public class StreamPumper extends Thread {
    private static final int SLEEP_TIME = 5;

    private BufferedReader din;
    private boolean endOfStream = false;
    private ProgressDialog progressDialog_;
    private Display display_;

    /**
     * RXgN^
     * 
     * @param is ̓Xg[
     * @param display \foCX
     * @param dlg i\_CAO
     */
    public StreamPumper(InputStream is, final Display display, ProgressDialog dlg) {
        this.din = new BufferedReader(new InputStreamReader(is));
        this.display_ = display;
        this.progressDialog_ = dlg;
    }

    /**
     * ̓Xg[sǂݍ݁Ai_CAOɕ\郁\bh
     * 
     * @throws IOException
     */
    public void pumpStream() throws IOException {
        if (!endOfStream) {
            final String line = din.readLine();

            if (line != null) {
				display_.asyncExec(new Runnable() {
					public void run() {
						progressDialog_.addText(line);
					}
				});
            } else {
                endOfStream = true;
            }
        }
    }

    /**
     * C
     */
    public void run() {
        try {
            while (!endOfStream) {
                pumpStream();
                sleep(SLEEP_TIME);
            }
            
            din.close();
        } catch (IOException ioe) {
            // ignore
        } catch (InterruptedException ie) {
            //ignore
        }
    }
}
