#include "stdafx.h"
#include "Util.h"

/**
 * WXgɕފ֐
 *
 * @param name L[
 * @param data l
 */
void SetIniDataString(std::string name, std::string data) 
{ 
	HKEY hKey; 
	LONG lResult; 
	
	lResult = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\k-soft\\TurukameSearch", 0, NULL, 
		REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKey, NULL); 
		
	if (lResult != ERROR_SUCCESS) {
		MessageBox(NULL, "RegCreateKeyEx failed", "", MB_OK);
		return;
	}
		
	lResult = RegSetValueEx(hKey, name.c_str(), 0, REG_SZ, (CONST BYTE *)data.c_str(), data.length()); 
	
	if (lResult != ERROR_SUCCESS) {
		MessageBox(NULL, "RegSetValueEx failed", "", MB_OK);
	}
	
	RegCloseKey(hKey); 
	
	return; 
}

/**
 * WXg當ǂݏo֐
 *
 * @param name L[
 * @param value l󂯎Astring^ϐւ̎Q
 */
bool GetIniDataString(std::string name, std::string& value) 
{ 
	HKEY hKey; 
	DWORD dwByte = 2000; 
	LONG lResult; 
	TCHAR buf[2000] = "";

	lResult = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\k-soft\\TurukameSearch", 0, NULL, 
		REG_OPTION_NON_VOLATILE, KEY_READ, NULL, &hKey, NULL); 

	if (lResult != ERROR_SUCCESS) {
		return false;
	}

	RegQueryValueEx(hKey, name.c_str(), NULL, NULL, (BYTE *)buf, &dwByte); 

	if (lResult != ERROR_SUCCESS) {
		RegCloseKey(hKey); 
		return false;
	}

	value = buf;
	RegCloseKey(hKey); 
	return true; 
}

/**
 * WXgɐlފ֐
 *
 * @param name L[
 * @param dwData l
 */
void SetIniDataDWORD(std::string name, DWORD dwData) 
{ 
	HKEY hKey; 
	LONG lResult; 
	
	lResult = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\k-soft\\DesktopHE", 0, NULL, 
		REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKey, NULL); 
		
	if (lResult != ERROR_SUCCESS) {
		MessageBox(NULL, "RegCreateKeyEx failed", "", MB_OK);
		return;
	}

	lResult = RegSetValueEx(hKey, name.c_str(), 0, REG_DWORD, (CONST BYTE *)&dwData, sizeof(DWORD)); 

	if (lResult != ERROR_SUCCESS) {
		MessageBox(NULL, "RegSetValueEx failed", "", MB_OK);
	}

	RegCloseKey(hKey); 
	
	return; 
}

/**
 * WXg琔lǂݏo֐
 *
 * @param name L[
 * @param dwValue l󂯎ADWORD^ϐւ̃|C^Q
 */
bool GetIniDataDWORD(std::string name, DWORD *dwValue) 
{ 
	HKEY hKey; 
	DWORD dwByte = 32; 
	LONG lResult; 
	
	lResult = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\k-soft\\DesktopHE", 0, NULL, 
		REG_OPTION_NON_VOLATILE, KEY_READ, NULL, &hKey, NULL); 

	if (lResult != ERROR_SUCCESS) {
		return false;
	}

	lResult = RegQueryValueEx(hKey, name.c_str(), NULL, NULL, (BYTE *)dwValue, &dwByte); 
	RegCloseKey(hKey); 
	
	return lResult == ERROR_SUCCESS; 
}

/**
 * ׂďɂ֐
 *
 * @param src ϊ̕
 * @return ϊ̕
 */
std::string SetLower(std::string &src)
{
    char* fname;
	fname = (char*)malloc(src.length() + 1);
    strcpy( fname, src.c_str());

    int i;
    for( i = 0; fname[i] != '\0'; i ++){
        fname[i] = tolower( fname[i]);
    }
    std::string str = fname;
	free(fname);
    return str;
}


