package hidemarumail;

import java.io.File;

import estraier.Database;

public class Main {

	/**
	 * C֐.
	 * Gۃ[̃f[^CfbNX
	 * 
	 * @param args [0]: Hyper Estraier DB̃pX
	 * @param args [1]: ݒi[tH_̃pX
	 */
	public static void main(String[] args) {
		assert args != null : "܂";
		assert args.length == 2 : "̐zƈقȂ܂Bargs.length: " + args.length;
		
		String indexPath = args[0];
		File settingDataFolder = new File( args[1] );

		if (!settingDataFolder.isDirectory()) {
			settingDataFolder.mkdirs();
		}
		
	    Database heDatabase = new Database();

	    if (!heDatabase.open(indexPath, Database.DBWRITER | Database.DBCREAT)) {
	    	System.err.println("error: " + heDatabase.err_msg(heDatabase.error()));
	    	return;
	    }
	    
	    DataImporter di = new DataImporter();
		di.importData(heDatabase, settingDataFolder);

		System.out.println("HidemaruMail Index Plugin: Closing Hyper Estraier database...");
		
		if (heDatabase != null) {
			heDatabase.close();
		}

		System.out.println("HidemaruMail Index Plugin: Done.");
	}

}
